(PackageInfo named: 'acceptit') preamble: 'nil'!
SystemOrganization addCategory: #'acceptit-Compiler'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
SystemOrganization addCategory: #'acceptit-Libraries'!
(PackageInfo named: 'acceptit') postscript: '"below, add code to be run after the loading of this package"
'!

WAComponent subclass: #ACTestRootComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 12:49'!
canBeRoot

^true! !

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 13:01'!
registerApplication

^WAAdmin 
		register: self
		asApplicationAt: 'ACTest'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'topa 6/23/2010 15:45'!
renderContentOn: html
 "I render everything by calling html"

	html paragraph: 'Hello World'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'db 6/29/2010 15:27'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Hello World'.! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 6/30/2010 14:03'!
and =

	 spaces <``And''> spaces <charNoNewline+>:body -> [body]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 6/30/2010 14:03'!
applyLines :rule =

	apply(rule):firstBody
	(lineEnd and)*:andBodies -> [{rule . firstBody} , andBodies]
! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 6/30/2010 14:01'!
given =

	 spaces <``Given''> spaces <charNoNewline+>:body -> [body]! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 09:39'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACParser methodsFor: 'parsing' stamp: 'db 6/29/2010 15:46'!
parseSelector: aByteString

	^ aByteString lines first asLegalSelector! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACParser methodsFor: 'shout' stamp: 'topa 6/14/2010 15:02'!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace  environment: anEnvironmentOrNil

	^ nil! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 6/30/2010 14:03'!
scenario =

	title:t lineEnd+
	applyLines(#given):given lineEnd
	applyLines(#when):when lineEnd
	applyLines(#then):then lineEnd? end -> [{#scenario. t. given. when. then}]
	! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 6/30/2010 14:04'!
then =

	 spaces <``Then''> spaces <charNoNewline+>:body -> [body]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 10:03'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 6/30/2010 14:04'!
when =

	 spaces <``When''> spaces <charNoNewline+>:body -> [body]! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
messagePart =

	{symbol:s string:body} -> ['	', s asMutator,' ''', body,'''', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/30/2010 14:27'!
rule =

	{symbol:s string+:bodies} -> [ String streamContents: [:stream | 
			bodies do: [:body | stream nextPutAll: '	self ';  nextPutAll: s asMutator; space; nextPutAll: body printString; nextPut: $.; cr]]]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:20:38.788'!
scenarioAnnotation

	^ String streamContents: [:stream |
		stream crtab; 	nextPutAll: '<scenario>'; cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:35'!
title =

	{symbol:t string:s} -> ['ACUserStory named: ', s asLegalSelector capitalized asSymbol printString, String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:31:49.937'!
translate =
	
	{symbol:type ?[type = #userStory] title:t messagePart:purpose messagePart:role messagePart:means}
		-> [t, purpose, role, means]
|	{symbol:type ?[type = #scenario] {symbol:ign string:t} rule:given rule:when rule:then}
		-> [t asLegalSelector, self scenarioAnnotation, given, when, then]! !

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'fg 7/8/2010 16:21'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |
			
		parseTree := self parserClass matchStream: origCodeStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
	] on: OM2Fail do: [:ignore |
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		classified: '-- scenarios --'
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 16:08:20.587'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:31'!
parserClass

	^ ACParser! !

!String methodsFor: '*acceptit' stamp: 'topa 6/16/2010 14:56'!
asCamelCase
	"Convert to CamelCase. Can be conveinient 
	in conjunction with #asLegalSelector 
	'A man, a plan, a canal, panama' asCamelCase.
	'A man, a plan, a canal, panama' asCamelCase asLegalSelector.
	'Here 123should % be 6 the name6 of the method' asCamelCase.
	'Here 123should % be 6 the name6 of the method' asCamelCase asLegalSelector."
	
	^ self class streamContents: [:stream | 
		self substrings do: [:sub |
			stream nextPutAll: sub capitalized]]! !

!String methodsFor: '*acceptit' stamp: 'topa 7/8/2010 15:06'!
withLeadingAuxiliaryNormalized

	({
		{'am'.'are'.'is'} -> 'is'.
		{'have'.'has'} -> 'has'.
		{'shall'. 'should'} -> 'should'.
		{'may'. 'might'} -> 'may'.
		{'will'. 'would'} -> 'will'.
		{'can'.'could'} -> 'can'.
	} as: Dictionary) keysAndValuesDo: [:key :value|
		(self beginsWithAnyOf: key) 
			ifTrue:[^ value, String space, (self copyAfter: Character space)]].
		
	 ^ self! !

!String methodsFor: '*acceptit' stamp: 'topa 7/8/2010 13:54'!
withoutLeadingSubject

	| s |
	s := self withBlanksCondensed.
	^ (s asLowercase beginsWithAnyOf: #( i he she it you we they ))
		ifTrue: [	s copyAfter: Character space]
		ifFalse: [s]! !

Object subclass: #ACAlbatrossLibrary
	instanceVariableNames: 'scenario browser testComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Libraries'!

ACAlbatrossLibrary class
	instanceVariableNames: 'browser'!

ACAlbatrossLibrary class
	instanceVariableNames: 'browser'!

!ACAlbatrossLibrary class methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:25'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACAlbatrossLibrary methodsFor: 'accessing' stamp: 'topa 7/14/2010 15:28'!
browser

	^ browser! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:39'!
buildDefaultConfiguration: aDictionary

	aDictionary 
		at: #albatrossSubjectApplication
			put: WAApplication new;
		at: #albatrossPort
			put: 8080! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'fg 7/11/2010 11:36'!
click: aButtonLabel
	
	self browser click: aButtonLabel.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 13:38'!
createTestComponent
	"See comment of #subjectApplication"
	
	^ (self subjectApplication configuration at: #rootClass) new! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:29'!
delay
	
	^ 0.5! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/11/2010 11:30'!
enter: aString for: aLabel
	
	self browser enter: aString for: aLabel.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 13:38'!
getTestComponent
	"I return the root component of the subject application"
	
	^ testComponent ifNil: [
		testComponent := self createTestComponent ]! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:26'!
scenario

	^scenario! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 11:26'!
scenario: anObject

	scenario := anObject! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:42'!
setUp
	| handler |	
	
	handler := ARequestHandler default reset; yourself.
	self wrapper port: (self scenario configuration at: #albatrossPort).
	self wrapper initializeWith: self subjectApplication for: self.
	
	browser := handler browser
		applicationUrl: self wrapper applicationUrl 
		driverUrl: self wrapper driverUrl.
	
	browser timeout: self timeout .
	browser responseDelay: self delay.
	browser open.
	browser timeout: self timeout.
	browser receiveOrTimeout.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 11:57'!
subjectApplication

	^ self scenario configuration at: #albatrossSubjectApplication
! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:46'!
tearDown

	self browser end.
	self wrapper port: nil.! !

!ACAlbatrossLibrary methodsFor: 'browsing' stamp: 'fg 7/11/2010 11:48'!
textExists: aString

	^self browser textExists: aString.! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'fg 7/9/2010 17:08'!
timeout
	^15! !

!ACAlbatrossLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:26'!
wrapper

	^ AComponentWrapper! !

Object subclass: #ACVerticalPrototypeLibrary
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACVerticalPrototypeLibrary class methodsFor: 'as yet unclassified' stamp: 'db 7/9/2010 12:45'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:11'!
givenHasAWebSite

	"see setUp. has to be done there, because albatross expects a 
	running service during setup."! !

!ACVerticalPrototypeLibrary methodsFor: 'accessing' stamp: 'db 7/9/2010 12:47'!
scenario

	^scenario! !

!ACVerticalPrototypeLibrary methodsFor: 'accessing' stamp: 'db 7/9/2010 12:47'!
scenario: anObject

	scenario := anObject! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:11'!
setUp

	WASwazooAdaptor startOn: (self scenario configuration at: #albatrossPort). 
	ACTestRootComponent registerApplication.
	(Delay forMilliseconds: 500) wait.
! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:12'!
tearDown

	 |adaptor |
		
	WADispatcher default unregister: 'ACTest'.
	adaptor := WAAdmin serverAdaptors detect: [:a | a port = 9999] ifNone: [nil].
	adaptor ifNotNil: [:a|
		a isRunning ifTrue: [ a stop ].
		(Delay forMilliseconds: 250) wait.
		(a isRunning or: [a isStopping]) ifTrue: [a kill]	].! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 09:34'!
thenSeeHelloWorld

	
	^ self scenario browser textExists: 'Hello World'! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 09:40'!
whenGoToTheWebSite

	" this is done by the Albatross lib. No need to implement "! !

TestCase subclass: #ACCompilerScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:47:47.591'!
testScenarioCompilation

	|scenario acMethod stMethod scenarioDecompiled |
	scenario := 'hello
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
	
	scenarioDecompiled := 'hello
		<scenario>
		self given: ''I have a web site''.
		self when: ''I go to the web site''.
		self then: ''I see "Hello World"''.'.
	
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: scenarioDecompiled in: self class classified: nil notifying: nil ifFail: [].
	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 16:33:35.829'!
testScenarioHasCorrectName

	|scenario acMethod |
	scenario := 'Here should be the name of the method
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
		
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	
	self 
		should: [acMethod selector =  'hereshouldbethenameofthemethod'].
		 ! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:07'!
directClassWithVariablesSet

	| theKlass |
	theKlass := (ACUserStory subclass: self klassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: ACUserStory category).
	^ theKlass purpose: 'impress the ladies'; role: 'Casanova'; means: 'Prosecco'.! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName

	^ klassName! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName: anObject

	klassName := anObject! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:01'!
parseTree

	^ ACTranslator match: (ACParser matchStream: 
'A Name For Testing
In order to impress the ladies
As a Casanova
I want Prosecco
' readStream with: #userStory withArgs: #() withPlaybackDebugging: false) with: #translate! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:08'!
removeTestClass

	self klassName ifNotNilDo: [:name | 
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 13:57'!
setUp

	self klassName: #ANameForTesting.! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 14:02'!
tearDown

	self removeTestClass.! !

!ACCompilerUserStoryTest methodsFor: 'testing' stamp: 'fg 6/11/2010 14:16:34.89'!
testUserStoryCompilation

	| direct indirect generated |
	direct := self directClassWithVariablesSet definition.
	self removeTestClass.
	indirect := (ACUserStory named: self klassName
		purpose: 'impress the ladies' 
		role: 'Casanova'
		means: 'Prosecco') definition.
	self removeTestClass.
	generated := (Compiler evaluate: self parseTree notifying: nil logged: false) definition.
	self removeTestClass.
	
	self 
		should: [direct = indirect];
		should: [indirect = generated].! !

TestCase subclass: #ACDeltaFunctionTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:28'!
klassName

	^klassName! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:28'!
klassName: anObject

	klassName := anObject! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:29'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:19'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:20'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'topa 7/8/2010 15:07'!
testWithHaveAsString
	"comment stating purpose of message"
	
	|testString expectedString |
	testString := 'have a WebSite'.
	expectedString := 'has a WebSite'.
	self assert:  (testString withLeadingAuxiliaryNormalized) = expectedString.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'topa 7/8/2010 15:09'!
testWithIAndHaveAsSelector
	"comment stating purpose of message"
	
	|testString expectedString |
	testString := 'I have a WebSite'.
	expectedString := 'has a WebSite'.
	
	self assert:  (testString withoutLeadingSubject withLeadingAuxiliaryNormalized) = expectedString.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'fg 7/8/2010 15:34'!
testWithIAndShouldAsSelector
	
	| userStory testString expectedSymbol |
	userStory := ('AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory) new.

	testString := 'I should have four cars in stock'.
	expectedSymbol := #givenShouldHaveFourCarsInStock.
	
	self assert: (userStory selectorForString: testString prefixed: #given) = expectedSymbol.
	! !

TestCase subclass: #ACParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

ACParserTest subclass: #ACParserScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:09'!
testScenarioAnd

	|and|
	and:= 'And I have a web site'.
	self should: [self match: and with: #and].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:10'!
testScenarioGiven

	|given|
	given:= 'Given I have a web site'.

	self should: [self match: given with: #given].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:11'!
testScenarioGivenAnd

	|given|
	given:= 
'Given I have a web site
And I am not logged in'.

	self should: [self match: given with: #applyLines withArgs: #(given)].	! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:35:50.72'!
testScenarioInvalidNewlinesMatch

|scenarioInvalidNewlines|
	
	scenarioInvalidNewlines := 'Given I have a web site
	
		When I go to the web site
		
		Then I see "Hello World"'.
	self shouldnt: [self match:  scenarioInvalidNewlines with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:03.478'!
testScenarioInvalidOrderMatch

|scenarioInvalidOrder|

	scenarioInvalidOrder:= 'When I go to the web site
		Given I have a web site
		Then I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidOrder with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:51.013'!
testScenarioInvalidSyntaxMatch
|scenarioInvalidSyntax|

	scenarioInvalidSyntax:= 'Gvien I have a web site
		Wehn I go to the web site
		Tehn I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidSyntax with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:13:37.893'!
testScenarioInvalidTrailersMatch

|scenarioInvalidTrailers|
scenarioInvalidTrailers:= 'Given I have a web site
	When I go to the web site
	Then I see "Hello World"
	Yes, This would be awesome.'.
	
	self shouldnt: [self match: scenarioInvalidTrailers with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 6/30/2010 13:10'!
testScenarioMatch

	|scenario|
	scenario:= 'Hello World
	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 6/30/2010 13:11'!
testScenarioMatchAnd
	
	|scenario|
	scenario:= 'Hello World
	Given I have a web site
	And I am not logged in
	When I go to the web site
	And I click "Login"
	Then I see "Hello"
	And I see "World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/15/2010 16:30:43.661'!
testScenarioMissingName
|scenario|

	scenario:= '	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self shouldnt: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:13'!
testScenarioThen
	
	|then|
	then := 'Then I see "Hello World"'.
	
	self should: [self match: then with: #then].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:14'!
testScenarioThenAnd
	
	|then|
	then := 
'Then I see "Hello"
And I see "World"'.
	
	self should: [self match: then with: #applyLines withArgs: #(then)].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:14'!
testScenarioWhen

	|when|
	when:= 'When I go to the web site'.
	self should: [self match: when with: #when].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:15'!
testScenarioWhenAnd

	|when|
	when:= 
'When I go to the web site
And I click "Login"'.

	self should: [self match: when with: #applyLines withArgs: #(when)].! !

!ACParserTest class methodsFor: 'as yet unclassified' stamp: 'topa 5/27/2010 14:50'!
isAbstract

	^ self == ACParserTest! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 6/30/2010 14:12'!
match: aString with: aRule

	^ self match: aString with: aRule withArgs: #()
! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 6/30/2010 14:12'!
match: aString with: aRule withArgs: args

	[ACParser matchAll: aString with: aRule withArgs: args]
		on: OM2Fail
		do: [^ false].
	^ true! !

ACParserTest subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:36:39.815'!
testUserStoryInvalidNewlinesMatch

	|userStoryInvalidNewlines|
	userStoryInvalidNewlines :='A Title
		In order to achieve something
		
		As a role
		
		I want to do something.'.
	self shouldnt: [self match: userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:18:37.474'!
testUserStoryInvalidOrderMatch

	|userStoryInvalidOrder|
	userStoryInvalidOrder := 'A Title
		As a role
		I want to do something
		In order to achieve something.'.
	self shouldnt: [self match: userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:19:35.46'!
testUserStoryInvalidSyntaxMatch

	|userStoryInvalidSyntax|
	userStoryInvalidSyntax := 'A Title
		In roder to achieve something
		Asa role
		I wnat ot do something.'.
	self shouldnt: [self match: userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:20:19.864'!
testUserStoryInvalidTrailersMatch

	|userStoryInvalidTrailers|
	userStoryInvalidTrailers := 'A Title
		In order to achieve something
		As a role
		I want to do something.
	
		This is cool
		'.
	self shouldnt: [self match: userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:21:18.908'!
testUserStoryMatch

	|userStory|
	userStory := 'A Title
		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match: userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:22:37.873'!
testUserStoryMeansMatch

	|means|
	means:= 'I want to do something.'.
	self should: [self match: means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:23:49.879'!
testUserStoryMeansOptionalToMatch

	|meansOptionalTo|
	meansOptionalTo := 'I want a cake.'.
	self should: [  self match: meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:24:39.316'!
testUserStoryMeansOptionalToWithAnMatch

|meansOptionalToWithAn|
	meansOptionalToWithAn :='I want an embedded sleeping hour.'.
	self should: [  self match: meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:26:24.557'!
testUserStoryMissingArgsMatch

	|userStoryMissingArgs|
	userStoryMissingArgs := 'A Title
		In order to
		As a
		I want'.
	self shouldnt: [self match: userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:27:38.785'!
testUserStoryNewlineAfterTitleMatch
	
	|userStoryNewlineAfterTitle|
	userStoryNewlineAfterTitle := 'A Title

		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match:  userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:28:44.094'!
testUserStoryPurposeMatch

	|purpose|
	purpose := 'In order to achieve something.'.
	self should: [  self match: purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:29:30.091'!
testUserStoryRoleMatch

	|role|
	role :=  'As a role'.
	self should: [ self match: role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:09.156'!
testUserStoryRoleWithAnMatch

	|roleWithAn|
	roleWithAn := 'As an emancipated role'.
	self should: [ self match: roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:47.067'!
testUserStoryRoleWithPluralMatch
	
	|roleWithPlural|
	roleWithPlural:='As roles'.
	self shouldnt: [ self match: roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:31:33.05'!
testUserStorySpacingMatch
	
	|userStorySpacing|
	userStorySpacing := 
	'A Title
	    In order to achieve something
		As a role
	 	 I want to do something.'.
	self should: [self match: userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

TestCase subclass: #ACTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testGivenMultiTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site' 'I am not logged in').
	sourceCode:= '	self given: ''I have a web site''.', String cr, '	self given: ''I am not logged in''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testGivenTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site').
	sourceCode:= '	self given: ''I have a web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:39'!
testMeansTranslation

	| pt |
	pt:= #(means 'do something.').
	self should: (ACTranslator match: pt with: #messagePart) = ('	means: ''do something.''', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:40'!
testPurposeTranslation

	| pt |
	pt:= #(purpose 'achieve something').
	self should: (ACTranslator match: pt with: #messagePart) = ('	purpose: ''achieve something''', String cr).
	! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:41'!
testRoleTranslation

	| pt |
	pt:= #(role 'role').
	self should: (ACTranslator match: pt with: #messagePart) = ('	role: ''role''', String cr).! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:30'!
testScenarioMultiTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site' 'I am not logged in')
			#(#when 'I go to the web site' 'I click "Login"')
			#(#then 'I see "Hello"' 'I see "World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self given: ''I am not logged in''.
	self when: ''I go to the web site''.
	self when: ''I click "Login"''.
	self then: ''I see "Hello"''.
	self then: ''I see "World"''.', String cr.
	self should: (ACTranslator match: pt with: #translate) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'fg 6/15/2010 16:14:45.921'!
testScenarioTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site')
			#(#when 'I go to the web site')
			#(#then 'I see "Hello World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #translate) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testThenMultiTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello"' 'I see "World"').
	sourceCode:= '	self then: ''I see "Hello"''.', String cr,'	self then: ''I see "World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:45'!
testThenTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello World"').
	sourceCode:= '	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:42'!
testTitleTranslation

	| pt |
	pt:= #(title 'A Title').
	self should: (ACTranslator match: pt with: #title) = ('ACUserStory named: #ATitle', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/14/2010 12:06'!
testUserStoryTranslation

	| pt source |
	pt:= #(userStory
		#(title 'A Title') 
		#(purpose 'achieve something') 
		#(role 'role') 
		#(means 'do something.')).
	source := 'ACUserStory named: #ATitle
	purpose: ''achieve something''
	role: ''role''
	means: ''do something.''
'.
	self should: (ACTranslator match: pt with: #translate) = source.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testWhenMultiTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site' 'I log in').
	sourceCode:= '	self when: ''I go to the web site''.', String cr,'	self when: ''I log in''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testWhenTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site').
	sourceCode:= '	self when: ''I go to the web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

TestCase subclass: #ACUserStory
	instanceVariableNames: 'stepLibraries configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'fg 6/30/2010 16:22'!
allTestSelectors

	^ (Pragma allNamed: #scenario in: self)
			collect: [:pragma | pragma selector]
! !

!ACUserStory class methodsFor: 'configuration' stamp: 'topa 7/14/2010 12:47'!
buildConfiguration: aDictionary

	"to be used in UserStories to override Libraries defaults"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:41'!
compilerClass
		
	^ self looksLikeUserStoryHeir
		ifTrue: [	ACCompiler]
		ifFalse: [super compilerClass]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:13'!
definition

	^ self == ACUserStory
		ifTrue: [super definition]
		ifFalse: [String streamContents: [:stream |
			stream
				nextPutAll: self userStoryString printString;  crtab;
				nextPutAll: 'as: ';
				nextPutAll: (super definition findTokens: ' ') first]]
				
"				nextPutAll: (super definition findTokens: ' ') first; space;
				nextPutAll: 'named: '; nextPutAll: self name printString; crtab;
				nextPutAll: 'purpose: '; nextPutAll: self purpose printString; crtab;
				nextPutAll: 'role: '; nextPutAll: self role printString; crtab;
				nextPutAll: 'means: '; nextPutAll: self means printString"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:23'!
isAbstract

	^ self == ACUserStory! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/1/2010 14:20'!
libraries

	^ #()! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:46'!
looksLikeUserStoryHeir
	"During recompilation of the ACUserStory class, all of
	#==, #inheritsFrom:, or #isKindOf: will fail, so we have to rely
	on the name of the class and walk the superclasses ourselves"
	
	self allSuperclassesDo: [:cls |
		cls name = #ACUserStory
			ifTrue: [^ true]].
	^ false! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means

	^means! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means: anObject

	means := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:48'!
named: aNameSymbol
purpose: purposeString
role: roleString
means: meansString

	|klass|		
	klass := self subclass: aNameSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	klass purpose: purposeString; role: roleString; means: meansString.
	
	^ klass! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/8/2010 14:03'!
newFrom: anObject

	(anObject isKindOf: String)
		ifTrue: [^ self userStoryFromString: anObject].

	^ super newFrom: anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 16:49'!
parserClass

	self name = #ACUserStory
		ifFalse: [
			" this is only necessary to avoid a (inapplicable) warning from the Browser"
			 ((thisContext client isKindOf: Browser) and: [
				(thisContext sender selector = #validateMessageSource:forSelector:) or:  [
				thisContext sender selector =	#validateMessageSource:forSelector:inClass: ]])
					ifTrue: [^ACParser]].
	^ super parserClass
! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose

	^purpose! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose: anObject

	purpose := anObject! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role

	^role! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role: anObject

	role := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:58'!
setUpUserStory

	"nothing. to be used for UserStory specific set up"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 15:02'!
shoutParserClass

	^ (self inheritsFrom: ACUserStory)
		ifTrue: [ACParser]
		ifFalse: [super shoutParserClass]! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 10:37'!
sourceCodeTemplate
	
	^ self looksLikeUserStoryHeir 
		ifTrue: [
'Name of scenario

Given some preconditions
And another preconditition
When a certain event is triggered
And another "action" is invoked
Then a criterion holds
And a second criterion should be valid']
		ifFalse: [super sourceCodeTemplate]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 7/14/2010 15:58'!
tearDownUserStory

	"nothing. to be used for UserStory specific tear down"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/30/2010 12:44'!
userStoryFromString: anObject

	| newClass |
	newClass := (Compiler 
		evaluate: (ACTranslator 
			match: (ACParser matchAll: anObject readStream with: #userStory withArgs: #()) 
			with: #translate)
		notifying: nil 
		logged: true).
	newClass class compile:
	('initialize
	
	super initialize.
	self userStoryString: ', anObject printString, '. ')
	classified: 'initialize-release'.
	^ newClass initialize! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:12'!
userStoryString

	^ userStoryString! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:11'!
userStoryString: aString

	userStoryString := aString.! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/15/2010 09:30'!
configuration

	^ configuration ifNil: [
		self configuration: IdentityDictionary new.
		self stepLibraries do: [:library |
			(library respondsTo: #buildDefaultConfiguration:) ifTrue: [
				library buildDefaultConfiguration: configuration]].
		self class buildConfiguration: configuration.
		configuration].
	! !

!ACUserStory methodsFor: 'accessing' stamp: 'topa 7/14/2010 15:20'!
configuration: anObject

	configuration := anObject! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 12:19'!
defaultTimeout

	"disable"
	^ 60! !

!ACUserStory methodsFor: 'error handling' stamp: 'topa 7/14/2010 15:22'!
doesNotUnderstand: aMessage

	| library |
	library := (self stepLibraries 
		detect: [:lib | lib respondsTo: aMessage selector]
		ifNone: [^ super doesNotUnderstand: aMessage]).
	^ aMessage sendTo: library! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'fg 7/8/2010 16:36'!
given: aString
	
	self perform: (self selectorForString: aString prefixed: #given) .! !

!ACUserStory methodsFor: 'initialize-release' stamp: 'topa 7/15/2010 09:31'!
initialize

	super initialize.
	self stepLibraries: OrderedCollection new.
	
	" initialize the delegate libraries"
	self class libraries do: [:library |
		self stepLibraries add: (library newForScenario: self)].! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 11:33'!
runCase
	
	<timeout: 10>

	[super runCase]
	on: NotYetImplemented
	do: [self signalFailure: 'Step not yet implemented']! !

!ACUserStory methodsFor: 'private' stamp: 'fg 7/8/2010 16:47'!
selectorForString: aString prefixed: aSymbol

	^ (aSymbol, 
		aString 
			withoutLeadingSubject 
			withLeadingAuxiliaryNormalized 
			asCamelCase)  asLegalSelector asSymbol! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 15:57'!
setUp

	super setUp.
	self class setUpUserStory.
	(self stepLibraries)
		do: [:library | (library respondsTo: #setUp) ifTrue: [library setUp]];
		do: [:library | (library respondsTo: #setUpUserStory:) ifTrue: [library setUpUserStory: self class name]];
		do: [:library | (library respondsTo: #setUpScenario:) ifTrue: [library setUpScenario: self selector]]		! !

!ACUserStory methodsFor: 'private' stamp: 'topa 7/14/2010 15:20'!
stepLibraries

	^stepLibraries! !

!ACUserStory methodsFor: 'private' stamp: 'topa 7/14/2010 15:20'!
stepLibraries: anObject

	stepLibraries := anObject! !

!ACUserStory methodsFor: 'running' stamp: 'topa 7/14/2010 15:57'!
tearDown


	(self stepLibraries)
		do: [:library | (library respondsTo: #tearDownScenario:) ifTrue: [library tearDownScenario: self selector]];
		do: [:library | (library respondsTo: #tearDownUserStory:) ifTrue: [library tearDownUserStory: self class name]];
		do: [:library | (library respondsTo: #tearDown) ifTrue: [library tearDown]].
	self class tearDownUserStory.
	super tearDown.! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'topa 7/15/2010 09:32'!
then: aString

	self assert: [self perform: (self selectorForString: aString prefixed: #then).].
	! !

!ACUserStory methodsFor: 'internal verbs' stamp: 'fg 7/8/2010 16:39'!
when: aString

	self perform: (self selectorForString: aString prefixed: #when) .! !

TestCase subclass: #ACVerticalPrototypeTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName

	^klassName! !

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName: anObject

	klassName := anObject! !

!ACVerticalPrototypeTest methodsFor: 'helper' stamp: 'fg 6/10/2010 19:57:56.355'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACVerticalPrototypeTest methodsFor: 'testing' stamp: 'topa 7/15/2010 15:11'!
testVerticalPrototype
	<timeout: 10>
	| userStory scenario numOfMethods storedMethod |

	userStory := 'AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory.
	self 
		should: [userStory inheritsFrom: TestCase];
		should: [userStory name = self klassName].
	
	numOfMethods := userStory methodDict size.
	scenario := userStory compile: 
'Hello World Test
Given I have a web site
When I go to the web site
Then I see "Hello World"'
						 classified: nil.
	self 
		should: [userStory methodDict size = (numOfMethods +1)];
		should: [userStory methodDict includesKey: scenario].
	
	" Configuration "
	userStory class compile: 'libraries ^ {ACVerticalPrototypeLibrary . ACAlbatrossLibrary}'.
	userStory class compile: 'buildConfiguration: aDictionary

	aDictionary 
		at: #albatrossSubjectApplication
			put: (WADispatcher default entryPointAt: ''ACTest'');
		at: #albatrossPort
			put: 9999.'.
	
	"ACTestRootComponent is hard coded in ACVerticalPrototypeTest"
	"generate empty renderContentOn:"
	storedMethod := ACTestRootComponent methodDict at: #renderContentOn: ifAbsent: [self error].
	[ACTestRootComponent methodDict removeKey: #renderContentOn:.
	self should: [(userStory run: scenario) hasFailures].
	] ensure: [ACTestRootComponent methodDict at: #renderContentOn: put: storedMethod].
	
	self should: [(userStory run: scenario)  hasPassed].! !
